#include <velib/qt/v_busitems.h>
#include "cmagent.h"

//#define QS_LOG_DISABLE
#include "QsLog.h"

CmAgent::CmAgent(QObject *parent) :
	QObject(parent),
	mAgent(this)
{
}

CmAgent::CmAgent(const QString &objectPath, QObject *parent) :
	QObject(parent),
	mAgent(this)
{
	path(objectPath);
}

CmAgent::~CmAgent()
{
	if (!mPath.isEmpty())
		VBusItems::getConnection().unregisterObject(mPath);
}

void CmAgent::path(const QString &objectPath)
{
	QLOG_TRACE() << "[CmAgent] Register object path" << objectPath;
	mPath = objectPath;
	VBusItems::getConnection().registerObject(objectPath,this);
}

void CmAgent::release()
{
	QLOG_INFO() << "[CmAgent] Release";
}

void CmAgent::reportError(const QDBusObjectPath &path, const QString &error)
{
	QLOG_ERROR() << "[CmAgent] Report error" << path.path() << error;
}

void CmAgent::requestBrowser(const QDBusObjectPath &path, const QString &url)
{
	QLOG_ERROR() << "[CmAgent] Request Browser" << path.path() << url;
}

QVariantMap CmAgent::requestInput(const QDBusObjectPath &path, const QVariantMap &fields)
{
	Q_UNUSED(fields);
	QLOG_TRACE() << "[CmAgent] Request Input" << path.path();
	QVariantMap map;
	map.insert("Passphrase", QVariant(mPassPhrase));
	return map;
}

void CmAgent::cancel()
{
	QLOG_INFO() << "[CmAgent] Cancel";
}
