#ifndef DBUS_SERVICES_H
#define DBUS_SERVICES_H

#include <QObject>
#include <QDBusConnection>
#include <QDBusConnectionInterface>

class DBusService;

class DBusServices : public QObject
{
	Q_OBJECT
	Q_PROPERTY(int count READ getCount)

public:
	DBusServices(QObject *parent = 0) : QObject(parent) {}
	void initialScan();
	int getCount() { return mServices.count(); }
	Q_INVOKABLE DBusService *at(int i) { return mServices.values()[i]; }
	bool event(QEvent *event);

signals:
	// note: found is called once, while connected / disconnected can
	// occur multiple times
	void dbusServiceFound(DBusService *service);
	void dbusServiceConnected(DBusService *service);
	void dbusServiceDisconnected(DBusService *service);

public slots:
	void serviceOwnerChanged(const QString &name, const QString &oldOwner, const QString &newOwner);

private:
	void processServiceName(QString name);
	QHash<QString, DBusService *> mServices;
};

#endif
