#include <velib/qt/lynxion_error.hpp>

QString LynxIonError::getDescription(int errorNumber)
{
	QString result = "#" + QString::number(errorNumber) + " ";

	switch (errorNumber)
	{
	case 1:
		result += tr("Battery initialization error");
		break;
	case 2:
		result += tr("No batteries connected");
		break;
	case 3:
		result += tr("Unknown battery");
		break;
	case 4:
		result += tr("Different battery types");
		break;
	case 5:
		result += tr("Nr of batteries incorrect");
		break;
	case 6:
		result += tr("Lynx Shunt not found");
		break;
	case 7:
		result += tr("Battery measure error");
		break;
	case 8:
		result += tr("Internal calculation error");
		break;
	case 9:
		result += tr("Batteries in series not ok");
		break;
	case 10:
		result += tr("Nr of batteries incorrect");
		break;
	case 11:
		result += tr("Hardware error");
		break;
	case 12:
		result += tr("Watchdog error");
		break;
	case 13:
		result += tr("Over voltage");
		break;
	case 14:
		result += tr("Under voltage");
		break;
	case 15:
		result += tr("Over temperature");
		break;
	case 16:
		result += tr("Under temperature");
		break;
	case 22:
		result += tr("ADC error");
		break;
	case 23:
		result += tr("Slave error");
		break;
	case 24:
		result += tr("Slave warning");
		break;
	case 25:
		result += tr("Pre-charge error");
		break;
	case 26:
		result += tr("Contactor error");
		break;
	case 27:
		result += tr("Over current");
		break;
	}

	return result;
}
