#include "notification.h"

Notification::Notification(Type type, const QString &devicename,
							const QString &description, const QString &value, QObject *parent) :
	QObject(parent),
	mAcknowledged(false), mActive(true), mType(type), mDevicename(devicename),
	mDateTime(QDateTime::currentDateTime()), mDescription(description), mValue(value)
{
}

QString Notification::getTypeAsString() const
{
	switch (mType)
	{
	case WARNING:
		return tr("Warning");
	case ALARM:
		return tr("Alarm");
	case NOTIFICATION:
		return tr("Notification");
	default:
		Q_ASSERT(false);
		return "error";
	}
}
