#ifndef _PLATFORM_VE_PLATFORM_HPP_
#define _PLATFORM_VE_PLATFORM_HPP_

//#include <velib/qt/ve_qitem.hpp>
#include <ve_qitems_settings.hpp>

#include <arguments.h>
#include <ve_quick_view.hpp>

class Application;

class VePlatform : public QObject
{
	Q_OBJECT

public:
	virtual void init(Application &app, Arguments &args) = 0;
	virtual void run(Arguments &args) = 0;
	virtual QString getLanguage() = 0;
	virtual void showView(VeQuickView *view) = 0;
	virtual QString themePath() = 0;
	virtual QString qmlUrl(QString path) = 0;
	virtual void qmlRegister(VeQuickView *view);

	// try to wakup the device if asleep, should return true if it the event was accepted
	virtual bool wakeupEvent() { return false; }
	// directly silence a buzzer, should return true if done so
	virtual bool silenceBuzzer() { return false; }

	static VePlatform *create(Application &app);

	/*
	 * At the moment the CCGX uses the Qt VNC server. Perhaps that is changed someday
	 * and the PC version does not have the build in VNC, hence it ends up here as
	 * a platform specific call. By default it fails.
	 */
	Q_INVOKABLE virtual bool setRemoteConsolePassword(const QString &password) {
		Q_UNUSED(password);
		return false;
	}

signals:
	void upAndRunning();

protected:
	VePlatform(Application &app) : mApp(app) {}
	Application &mApp;
	VeQItemSettings *mSettings;
};

#endif
