#ifndef QWACSGATEWAYINTERFACE_H
#define QWACSGATEWAYINTERFACE_H

#include <QObject>
#include <QtDBus/QtDBus>

class QwacsGatewayInterface : public QDBusAbstractInterface
{
	Q_OBJECT
public:
	static inline const char *staticInterfaceName()	{ return "com.victronenergy.gateway"; }

	QwacsGatewayInterface(const QString &service, const QString &path, const QDBusConnection &connection, QObject *parent = 0);

public slots:
	QVariant getProperty(const char *name) const { return mProperties.property(name); }

	QDBusPendingReply<int> getUplink() { return call("GetUplink"); }

	QDBusReply<int> setUplink(const bool enable) { return call("SetUplink", enable); }

	QDBusReply<int> blinkOn(const QString & id)
		{ return call("BlinkOn", id); }

	QDBusReply<int> blinkOff(const QString & id)
		{ return call("BlinkOff", id); }

signals:
	void PropertiesChanged(const QVariantMap &changes);
	void UplinkStatus(const QString & status);

private:
	QDBusInterface mProperties;
};

#endif // QWACSGATEWAYINTERFACE_H
