#ifndef QWACSMANAGERINTERFACE_H
#define QWACSMANAGERINTERFACE_H

#include <QObject>
#include <QtDBus/QtDBus>

class QwacsManagerInterface : public QDBusAbstractInterface
{
	Q_OBJECT
public:
	static inline const char *staticInterfaceName()	{ return "com.victronenergy.manager"; }

	QwacsManagerInterface(const QString &service, const QString &path, const QDBusConnection &connection, QObject *parent = 0);

public slots:
	QVariant getProperty(const char *name) const { return mManagerProperties.property(name); }

signals:
	void PropertiesChanged(const QVariantMap &changes);
	void gatewayFound(const QString &hostname);
	void sensorAdded(const QString &id);

private:
	QDBusInterface mManagerProperties;
};

#endif // QWACSMANAGERINTERFACE_H
