#ifndef RELAY_H
#define RELAY_H

#include <QObject>
#include <QString>
#include <notification_center.h>
#include <velib/qt/ve_qitem.hpp>

class Relay : public QObject
{
	Q_OBJECT
	Q_PROPERTY(bool relayOn READ getRelayOn WRITE setRelayOn NOTIFY relayOnChanged)

public:
	Relay(QString relayPath, NotificationCenter *notificationCenter, QObject *parent = 0);
	bool getRelayOn() const;
	Q_INVOKABLE void setRelayOn(bool on);

private:
	void setHwState(bool closed);
	VeQItem *mPolaritySetting;
	VeQItem *mRelayFunction;
	VeQItem *mRelayState;
	NotificationCenter *mNotificationCenter;
	bool mIntendedState;

private slots:
	void updateRelayState();
	void alarmChanged();

signals:
	void relayOnChanged();
};

#endif
