#ifndef TIMEZONE_H
#define TIMEZONE_H

#include <QObject>
#include <QtDeclarative>
#include <velib/qt/ve_qitem.hpp>
#include <ve_qitems_settings.hpp>

class TimeZone : public QObject
{
	Q_OBJECT
	Q_PROPERTY(QString city READ getCity WRITE setCity NOTIFY cityChanged)
	Q_PROPERTY(QString region READ getRegion WRITE setRegion NOTIFY regionChanged)

public:
	TimeZone(VeQItemSettings *settings, QObject *parent = 0);
	QString getCity();
	void setCity(QString city);
	QString getRegion();
	void setRegion(QString region);

signals:
	void cityChanged();
	void regionChanged();

private slots:
	void valueChanged(VeQItem *item, QVariant var);

private:
	VeQItem *mBusitemValue;

	QString mCity;
	QString mRegion;
};

#endif
