#ifndef _VE_QUICK_ITEM_MODEL_BUILDER_HPP_
#define _VE_QUICK_ITEM_MODEL_BUILDER_HPP_

#include <QDeclarativeListProperty>
#include <QStringList>

#include <velib/qt/ve_qitem.hpp>
#include <velib/qt/ve_qitem_table_model.hpp>

class VeQuickItemModelBuilder : public VeQItemTableModel {
	Q_OBJECT
	Q_PROPERTY(QStringList uids READ getUids WRITE setUids NOTIFY uidsChanged)

public:

	VeQuickItemModelBuilder(QObject *parent = 0) :
		VeQItemTableModel(VeQItemTableModel::VeQItemModelAddChildren | VeQItemTableModel::VeQItemModelAddNoneLeaves, parent)
	{
	}

	Q_INVOKABLE void addItem(QString uid) { VeQItemTableModel::addItem(VeQItems::getRoot()->itemGetOrCreate(uid)); }

	/*
	 * WARNING: when a value inside the list is changed, the declarative engine will
	 * write the whole modified list again!
	 */
	QStringList getUids() { return mUids; }
	void setUids(const QStringList &uids) {
		qDebug() << uids;
		mUids = uids;

		foreach (QString uid, mUids) {
			VeQItem *item = VeQItems::getRoot()->itemGet(uid);
			if (item == 0) {
				qDebug() << "VeQuickItemModelBuilder: item does not exists!" << uid;
				continue;
			}
			VeQItemTableModel::addItem(item);
		}
		emit uidsChanged();
	}

signals:
	void modelChanged();
	void uidsChanged();

private:
	QStringList mUids;
};

#endif
