#ifndef _VE_QUICK_VIEW_HPP_
#define _VE_QUICK_VIEW_HPP_

#include <qmlapplicationviewer.h>
#include <notification_center.h>

class VePlatform;

/* Qt 4 version of QML */
class VeQuickView : public QmlApplicationViewer
{
Q_OBJECT

public:
	VeQuickView(VePlatform *platform, QWidget *parent = 0);

	void qmlRegister();
	void loadApplication();

	Q_INVOKABLE void keyAccepted();

signals:
	void keyPressed(int key);

protected:
	void keyPressEvent(QKeyEvent *event);
	void keyReleaseEvent(QKeyEvent *event);

private:
	void takeSnapshot();

	VePlatform *mPlatform;
	NotificationCenter mNotificationCenter;
	int mLastKeyStillPressed;
	bool mWakeUpEvent;
	bool mKeyAccepted;
};

#endif
